//+------------------------------------------------------------------+
//|                                                       iTrend.mq4 |
//|                             Copyright  2010, EGEN Software LTD. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright   "Copyright  2010, EGEN Software LTD."
#property link        "http://www.metaquotes.net"

#property indicator_separate_window

#property indicator_minimum     -12
#property indicator_maximum      12
#property indicator_buffers      2
#property indicator_color1       Red
#property indicator_color2       Yellow
#property indicator_level1       6
#property indicator_level2       0
#property indicator_level3      -6
#property indicator_levelcolor   Silver

extern bool Fractals =  true;
extern bool Cross    =  true;

double TREND.1[];
double TREND.2[];

int MIN(int value1, int value2)
{
   if(value1<value2) return(value1); 
   return(value2);   
}

int SIGN(int value)
{
   if(value<0) 
      return(-1); 
   if(value>0) 
      return(1);
   return(0);
}

double OPEN(int timeframe, int shift)
{
   return(iOpen(NULL,timeframe,shift));
}

double CLOSE(int timeframe, int shift)
{
   return(iClose(NULL,timeframe,shift));
}

double FRACTALS(int timeframe, int mode, int shift)
{
  return(iFractals(NULL,timeframe,mode,shift));
}

bool UPPER(int timeframe, int shift)
{
   return(FRACTALS(timeframe,MODE_UPPER,shift)>0);
}

bool LOWER(int timeframe, int shift)
{
   return(FRACTALS(timeframe,MODE_LOWER,shift)>0);   
}

int PEAK(int timeframe, int shift)
{
   int peak=0;
   if(UPPER(timeframe,shift)) peak++;
   if(LOWER(timeframe,shift)) peak--;
   return(peak);
}

int DELTA(double value1, double value2)
{
   if(value1<value2) 
      return(-1);
   if(value1>value2) 
      return(1);
   return(0);      
}

int BODY(int timeframe, int shift)
{
   return(DELTA(CLOSE(timeframe,shift),OPEN(timeframe,shift)));
}

int TICK(int timeframe, int shift)
{
   if(Fractals) 
      return(PEAK(timeframe,shift)); 
         else 
      return(BODY(timeframe,shift));   
}

int BARS(int timeframe, int shift)
{
   return(MIN(iBars(NULL,timeframe),(PERIOD_D1+shift)/timeframe));
}

int FRAME(int timeframe, int shift)
{      
   int frame=0;          
   for(int i=shift/timeframe; i<BARS(timeframe,shift); i++) 
      frame+=TICK(timeframe,i);
   return(SIGN(frame));
}

bool TOTAL(int index)
{
   return(index<MIN(Bars-IndicatorCounted(),PERIOD_D1));
}

void init()
{
   IndicatorBuffers(2);
   SetIndexBuffer(0,TREND.1);
   SetIndexStyle(0,DRAW_LINE);      
   SetIndexBuffer(1,TREND.2);
   SetIndexStyle(1,DRAW_LINE);         
   IndicatorDigits(0);
   IndicatorShortName("iTrend");  
   SetLevelValue(0,6);
   SetLevelValue(1,0);
   SetLevelValue(2,-6);   
   SetLevelStyle(STYLE_DOT,EMPTY);
}

void TREND(int index)
{
   int trend1=FRAME(PERIOD_M1,index);
   int trend2=FRAME(PERIOD_M5,index);   
   int trend3=FRAME(PERIOD_M15,index);   
   int trend4=FRAME(PERIOD_M30,index);      
   int trend5=FRAME(PERIOD_H1,index);      
   int trend6=FRAME(PERIOD_H4,index);   
   int S=trend1+trend2+trend3+trend4+trend5+trend6;  
   trend2=SIGN(trend2+trend1);
   trend3=SIGN(trend3+trend2);
   trend4=SIGN(trend4+trend3);
   trend5=SIGN(trend5+trend4);
   trend6=SIGN(trend6+trend5);
   int T=trend1+trend2+trend3+trend4+trend5+trend6; 
   TREND.1[index]=S+T;   
   if(Cross) T=T-S; else T=S-T;
   TREND.2[index]=T;   
}      

void start()
{
   for(int i=0; TOTAL(i); i++) TREND(i);  
}

